import java.io.*;
import java.util.Enumeration;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Outputs parameters submitted to it via an HTTP GET.
 *
 * @author  Computer Science E-259
 *
 * @throws IOException, ServletException
 */

public class Parameters extends HttpServlet {

    public void doGet(HttpServletRequest request, 
                      HttpServletResponse response)
    throws IOException, ServletException
    {
        // output plain text
        response.setContentType("text/plain");

        // grab PrintWriter
        PrintWriter out = response.getWriter();

        // grab submitted parameters
        Enumeration params = request.getParameterNames();

        // output each parameter's name and value
        while (params.hasMoreElements())
        {
            String param = (String) params.nextElement();
            out.println(param + ": " + request.getParameter(param));
        }
    }
}
