#!/usr/local/bin/perl
#
# http.cgi
#
# A Perl script that echoes the content of an HTTP request.
#
# Based on Steven E. Brenner's cgi-lib.pl, available at
# http://cgi-lib.berkeley.edu/.
#

# get request's content type
$type = $ENV{'CONTENT_TYPE'};

# get request's content length
$len  = $ENV{'CONTENT_LENGTH'};

# get request's request method
$meth = $ENV{'REQUEST_METHOD'};

# read request
if (!defined $meth || $meth eq '') {
    $in = $ENV{'QUERY_STRING'};
} elsif($meth eq 'GET' || $meth eq 'HEAD') {
    $in = $ENV{'QUERY_STRING'};
} elsif ($meth eq 'POST') {
    if (($got = read(STDIN, $in, $len) != $len))
	{ die("Short Read: wanted $len, got $got\n"); }
} else {
    die("Unknown request method: $meth\n");
}

# echo content of request
print <<EOT;
Content-type: text/plain

$in
EOT
